﻿Public Class MisImpresiones

    Friend NombreArchivoParaImpresora As String
    Private MiPrintPreviewDialog As PrintPreviewDialog
    Private MiPrintDialog As PrintDialog
    Private WithEvents MiPrintDocument As System.Drawing.Printing.PrintDocument
    Private MiDoc As System.IO.StreamReader

    Private Sub MiPrintDocument_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles MiPrintDocument.PrintPage
        Dim Ligne As String
        Dim Position As System.Drawing.PointF
        Dim Rectangle As RectangleF
        Dim Police As Font = Nothing
        Dim AlturaLinea As Single
        Static NumeroPagina As Integer = 0

        Dim NumeroLinea As Integer = 0
        Dim TopPrecedente As Integer = e.MarginBounds.Top

        Dim SeparadorSplit As Char() = {"~"}
        Dim LosCampos() As String   ' Este es un tabla de String
        Dim LineaParaImpresora As String = ""

        NumeroPagina += 1

        Do Until MiDoc.Peek = -1               ' Leer el archivo linea por linea 

            Ligne = MiDoc.ReadLine()   ' Leer una linea 

            '         If Linea = String.Empty Then Exit While
            LosCampos = Ligne.Split(SeparadorSplit)

            ' Aquí son las posibilidades de ajustar formato. Este es el mas difficile.
            Dim CuantidadColumnaDGV As Integer
            Select Case LosCampos(0)
                Case "TBPro"  ' El TextBox TBProba (1 valor)
                    LineaParaImpresora = LosCampos(1)
                    Police = New Font("Courier New", 16, FontStyle.Bold)

                Case "CBPro"  ' El cuantidad de textos en el ComboBox CBProba y su valor Text  (2 valores)
                    LineaParaImpresora = "El ComboBox tiene " & LosCampos(1) & " valores y el texto visible es " & LosCampos(2)
                    Police = New Font("Courier New", 12, FontStyle.Regular)

                Case "LBPro" ' El cuantidad de textos en el ListoBox LBProba y el valor del seleccion (2 valores)
                    LineaParaImpresora = "El ListBox tiene " & LosCampos(1) & " valores y el texto seleccionado es " & LosCampos(2)
                    Police = New Font("Courier New", 12, FontStyle.Regular)

                Case "ChkTx" ' El mensaje libre y la indicacion si tiene que lo imprimir (2 valores)
                    If CType(LosCampos(1).ToString, Boolean) Then
                        LineaParaImpresora = "El mensaje libre es " & LosCampos(2)
                    Else
                        LineaParaImpresora = "Nunca mensaje"
                    End If
                    Police = New Font("Courier New", 12, FontStyle.Regular)

                Case "DGVHd" ' El cuantidad de Columnas y los ColumnsHeader del DatagridView DGV 
                    CuantidadColumnaDGV = CType(LosCampos(1).ToString, Integer)
                    LineaParaImpresora = ""
                    For C As Integer = 0 To CuantidadColumnaDGV - 1
                        LineaParaImpresora &= LosCampos(C + 2) & "          "
                    Next

                Case "DGVal" ' El cuantidad de lineas y los valores de cada Cell del DatagridView DGV 
                    LineaParaImpresora = LosCampos(2).PadLeft(8, " ") & "          " _
                        & LosCampos(4) & "               " _
                        & LosCampos(3) & "          " _
                        & LosCampos(5).PadLeft(8, " ")
            End Select

            ' Tambien es posible aqui de formatar los espaciados ente los informaciones y definir la position del Rectangle

            AlturaLinea = Police.GetHeight(e.Graphics)
            TopPrecedente += AlturaLinea
            Position = New PointF(e.MarginBounds.Left, TopPrecedente)
            Rectangle.Location = Position
            e.Graphics.DrawString(LineaParaImpresora, Police, Brushes.Black, Rectangle)

            NumeroLinea += 1

            If LosCampos(0) = "DGVHd" Then  ' Subrayar los titulos 
                e.Graphics.DrawLine(Pens.Black, e.MarginBounds.Left, TopPrecedente + AlturaLinea, e.MarginBounds.Right, TopPrecedente + AlturaLinea)
            End If

            If TopPrecedente + AlturaLinea > e.MarginBounds.Height Then Exit Do
        Loop

        If MiDoc.Peek <> -1 Then
            e.HasMorePages = True
        Else
            MiDoc.Close()
            MiDoc = New System.IO.StreamReader(NombreArchivoParaImpresora)
        End If
    End Sub

    Private Sub MisImpreciones_Closed(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Closed
        MiPrintDialog.Dispose()
        MiPrintPreviewDialog.Dispose()
        MiDoc.Close()
    End Sub

    Private Sub MisImpreciones_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None
        If NombreArchivoParaImpresora = String.Empty OrElse Not System.IO.File.Exists(NombreArchivoParaImpresora) Then
            Me.Close()
        End If
        MiPrintPreviewDialog = New PrintPreviewDialog
        MiPrintDialog = New PrintDialog
        MiPrintDocument = New System.Drawing.Printing.PrintDocument
        Dim Resultado As DialogResult
        MiPrintDialog.Document = MiPrintDocument  ' Elimimar 3 lineas si no seleccion de la impresora
        Resultado = MiPrintDialog.ShowDialog()
        If Resultado = Windows.Forms.DialogResult.OK Then
            MiPrintPreviewDialog.Document = MiPrintDocument
            MiPrintDocument.DocumentName = NombreArchivoParaImpresora
            MiDoc = New System.IO.StreamReader(MiPrintDocument.DocumentName)
            MiPrintPreviewDialog.Dock = DockStyle.Fill
            Resultado = MiPrintPreviewDialog.ShowDialog()
            If Resultado = Windows.Forms.DialogResult.OK Then
                MiDoc.Close()
                MiDoc.Dispose()
            Else
                Me.Close()
            End If
        End If
    End Sub
End Class


